package com.xhkjedu.sapi.controller.appversion;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.xhkjedu.sapi.model.appversion.TAppStulive;
import com.xhkjedu.sapi.service.appversion.AppStuliveService;
import com.xhkjedu.utils.N_Utils;
import com.xhkjedu.utils.PageUtil;
import com.xhkjedu.vo.PageResult;
import com.xhkjedu.vo.ResultVo;
import com.xhkjedu.sapi.vo.appversion.AppversionVo;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author ywx
 * @classname AppStuliveController
 * @description 学生直播端
 * @date 2021/3/9 16:09
 **/
@RestController
@RequestMapping("/apppc_stu")
public class AppStuliveController {
    @Resource
    private AppStuliveService appStuliveService;

    @PostMapping("/add")
    public ResultVo add(@RequestBody TAppStulive appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionname(),"版本名称",2,
                appclient.getVersioncode(),"版本号",2,appclient.getVersionpath(),"应用文件",2});
        Integer id = appStuliveService.save(appclient);
        return new ResultVo(0, "保存成功",id);
    }

    @PostMapping("/delete")
    public ResultVo delete(@RequestBody TAppStulive appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionid(),"版本id",1});
        appStuliveService.deleteById(appclient.getVersionid());
        return new ResultVo(0,"删除成功");
    }

    @PostMapping("/update")
    public ResultVo update(@RequestBody TAppStulive appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionid(),"版本id",1});
        appStuliveService.update(appclient);
        return new ResultVo(0,"修改成功");
    }

    @PostMapping("/detail")
    public ResultVo detail(@RequestBody TAppStulive appclient) {
        N_Utils.validation(new Object[]{appclient.getVersionid(),"版本id",1});
        TAppStulive client = appStuliveService.findById(appclient.getVersionid());
        return new ResultVo(0,"获取详情成功",client);
    }

    @PostMapping("/list")
    public ResultVo list(@RequestBody TAppStulive appclient) {
        PageHelper.startPage(appclient.getPage(), appclient.getPageSize());
        List<AppversionVo> list = appStuliveService.listAll();
        PageResult pageResult = PageUtil.getPageResult(new PageInfo(list));
        return new ResultVo(0,"获取app版本列表成功",pageResult);
    }

    @PostMapping("/get_new")
    public ResultVo getNew() {
        TAppStulive appclient = appStuliveService.getNew();
        return new ResultVo(0,"获取最新app版本成功",appclient);
    }
}
